# class Byebug::Interface

Main Interface class

Contains common functionality to all implemented interfaces.

### Attributes

command_queue[RW]
error[R]
history[RW]
input[R]
output[R]

### Public Class Methods

new() click to toggle source

    # File lib/byebug/interface.rb, line 17
    def initialize
      @command_queue, @history = [], History.new
    end

### Public Instance Methods

autorestore() click to toggle source

Restores history according to `autosave` setting.

    # File lib/byebug/interface.rb, line 92
    def autorestore
      history.restore if Setting[:autosave]
    end

autosave() click to toggle source

Saves or clears history according to `autosave` setting.

    # File lib/byebug/interface.rb, line 85
    def autosave
      Setting[:autosave] ? history.save : history.clear
    end

close() click to toggle source

    # File lib/byebug/interface.rb, line 79
    def close
    end

confirm(prompt) click to toggle source

Confirms user introduced an affirmative response to the input stream.

    # File lib/byebug/interface.rb, line 75
    def confirm(prompt)
      readline(prompt) == 'y'
    end

errmsg(message) click to toggle source

Prints an error message to the error stream.

    # File lib/byebug/interface.rb, line 57
    def errmsg(message)
      error.print("*** #{message}\n")
    end

print(message) click to toggle source

    # File lib/byebug/interface.rb, line 68
    def print(message)
      output.print(message)
    end

puts(message) click to toggle source

Prints an output message to the output stream.

    # File lib/byebug/interface.rb, line 64
    def puts(message)
      output.puts(message)
    end

read_command(prompt) click to toggle source

Pops a command from the input stream.

    # File lib/byebug/interface.rb, line 24
    def read_command(prompt)
      return command_queue.shift unless command_queue.empty?

      cmds = read_input(prompt)
      return unless cmds

      command_queue.concat(cmds)
      command_queue.shift
    end

read_file(filename) click to toggle source

Pushes lines in `filename` to the command queue.

    # File lib/byebug/interface.rb, line 38
    def read_file(filename)
      command_queue.concat(get_lines(filename))
    end

read_input(prompt, save_hist = true) click to toggle source

Reads a new line from the interface's input stream.

    # File lib/byebug/interface.rb, line 45
    def read_input(prompt, save_hist = true)
      line = readline(prompt)
      return unless line

      history.push(line) if save_hist

      split_commands(line)
    end

### Private Instance Methods

split_commands(cmd_line) click to toggle source

Splits a command line of the form “cmd1 ; cmd2 ; … ; cmdN” into an array of commands: [cmd1, cmd2, …, cmdN]

    # File lib/byebug/interface.rb, line 102
    def split_commands(cmd_line)
      return [''] if cmd_line.empty?

      cmd_line.split(/;/).each_with_object([]) do |v, m|
        if m.empty? || m.last[-1] != '\'
          m << v
          next
        end

        m.last[-1, 1] = ''
        m.last << ';' << v
      end
    end